//+------------------------------------------------------------------------
// INTERFACE EventDispatcher
//------------------------------------------------------------------------
function makeEventDispatcher(eventClassID, obj) {
	// attach an interface for event dispatching to the object
	obj.listeners = new Array();
	obj.eventClassID = eventClassID;
	
	obj.addListener = EventDispatcher_addListener;
	obj.removeListener = EventDispatcher_removeListener;
}

//------------------------------------------------------------------------
function EventDispatcher_addListener(obj) {
	this.listeners[this.listeners.length] = obj;
}

//------------------------------------------------------------------------
function EventDispatcher_removeListener(obj) {
	
}

//+------------------------------------------------------------------------
// CLASS EventListener
//------------------------------------------------------------------------
function EventListener() {
	return this;
}

//+------------------------------------------------------------------------
// CLASS Event
//------------------------------------------------------------------------
function Event(dispatcher, name) {
	//+--------------- PROPERTIES
	this.dispatcher = dispatcher;
	this.name = name;
	
	//+--------------- EVENTS
	this.fire = Event_fire;
}

function Event_fire() {
	for (var i = 0; i <= this.dispatcher.listeners.length-1; i++) {
		if (eval('this.dispatcher.listeners[i].'+this.dispatcher.eventClassID+this.name)) {
			eval('this.dispatcher.listeners[i].'+this.dispatcher.eventClassID+this.name)(this.dispatcher);
		}
	}
}